OMG INTERFACE DEFINITION LANGUAGE COMPILER FRONT END: COMMAND LINE INTERFACE
-==========================================================================-

INTRODUCTION

This document describes general OMG Interface Definition Language compiler
command line options. Options that are specific to a given back end, object
adapter or language are not described here. These should be described in a
document detailing the interface implemented by each specific back end.

OMG INTERFACE DEFINITION LANGUAGE COMMAND LINE OPTIONS

OMG Interface Definition Language compiler options are described below.
Unless otherwise noted, only one occurrence of each option is allowed.
The following conventions are used

- Text in '[..]' is optional.
- Text followed by '*' can be repeated zero or more times.
- Text followed by '+' can be repeated once or more times.
- '{' and '}' are used to group text to cause '+' or '*' to apply to
  the entire grouped text.
- 'aa|bb' means either 'aa' or 'bb'.

COMMAND LINE SUMMARY

	idl [flag | file-name]*

Flags are command line words that start with a '-'. All other command line
words are assumed to be file names. If no file names are given, input is
taken from stdin.

COMMAND LINE FLAGS

-A[xyz]	A local escape. This can be used to specify additional options that
	are specific to a given implementation. More than one -A option is
	allowed

-Dname[=value]
	Defines name and an optional value to be passed to a compliant C++
	preprocessor, as if by #define. White space between the -D option
	and the name is optional. More than one -D option is allowed.

-d	If no parse errors were found, prints out a representation of the
	IDL input to stderr.

-E	Runs the C++ preprocessor on the OMG Interface Definition Language
	input and sends the result to the standard output.

-Idirectory
	Causes directory to be added to the search path for include files.
	More than one -I option is allowed. This option is processed by a
	compliant C++ preprocessor.

-Uname	Undefines name, as if by #undef. White space between the -U option
	and the name is optional. More than one -U option is allowed.

-V	Causes the version information of the CFE to be displayed. No other
	work is done, regardless of any other options.

-W[b|p][,arg]+
	Hands off the arguments supplied to a specific portion of the OMG
	Interface Definition Language compiler:

	- -Wb arguments are handed to the loaded back end
	- -Wp arguments are handed to a compliant C++ preprocessor

-Yp,pathname
	Specifies an alternate path for finding a C++ compliant
	preprocessor. Specifiers other than 'p' may be defined in future
	versions of the CFE. More than one -Y option may appear. The last
	one specifying each component takes effect.

	This option exists but currently does nothing. Instead, we use the
	preprocessing facilities provided by invoking CC -E always.

-bback_end
	Causes the CFE to use a different compiler back end than the
	default one (if dynamic loading is supported). Legal values for
	this option and the default value are implementation specific.

-u	Prints a usage message from the CFE. All possible options are
	shown. No other work is done regardless of any other options.

-v	Causes the CFE to produce informational output as the various
	phases of the compiler execute.

-w	Suppresses IDL compiler warning messages.


WHITESPACE

All option arguments may be separated from their option letter by
whitespace. For example, -D FOO is equivalent to -DFOO.

UNKNOWN OPTIONS

If an unknown option is passed to the CFE, the offending option is
displayed to the user together with a usage message, and no compilation is
performed.

PASSING OPTIONS TO COMPILER PHASES

The order in which options appear on the command line is preserved when
they are passed to various compiler phases.

MUTUALLY EXCLUSIVE OPTION COMBINATIONS

Mutually exclusive or ambiguous option combinations are resolved by using
the option that appears later on the command line. For example,

    -DFOO -UFOO

has no effect and leaves FOO undefined for the preprocessor.

OPTION SCOPE

All options are in effect for the entire IDL compilation run. If multiple
IDL source file names are given on the command line, all options apply to
each file. If different IDL source files require different sets of options
for successfull compilation, they must be compiled separately.

EXIT STATUS

IDL Compilers exit with status equal to zero for successfull compilations.
If errors were found by the CFE, the exit status is a count of the errors.
The exit status for unsuccessfull compilations aborted by BEs is defined by
each BE.

NOTE:

SunOS, SunSoft, Sun, Solaris, Sun Microsystems or the Sun logo are
trademarks or registered trademarks of Sun Microsystems, Inc.

COPYRIGHT NOTICE:

Copyright 1992, 1993, 1994 Sun Microsystems, Inc.  Printed in the United
States of America.  All Rights Reserved.

This product is protected by copyright and distributed under the following
license restricting its use.

The Interface Definition Language Compiler Front End (CFE) is made
available for your use provided that you include this license and copyright
notice on all media and documentation and the software program in which
this product is incorporated in whole or part. You may copy and extend
functionality (but may not remove functionality) of the Interface
Definition Language CFE without charge, but you are not authorized to
license or distribute it to anyone else except as part of a product or
program developed by you or with the express written consent of Sun
Microsystems, Inc. ("Sun").

The names of Sun Microsystems, Inc. and any of its subsidiaries or
affiliates may not be used in advertising or publicity pertaining to
distribution of Interface Definition Language CFE as permitted herein.

This license is effective until terminated by Sun for failure to comply
with this license.  Upon termination, you shall destroy or return all code
and documentation for the Interface Definition Language CFE.

INTERFACE DEFINITION LANGUAGE CFE IS PROVIDED AS IS WITH NO WARRANTIES OF
ANY KIND INCLUDING THE WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS
FOR A PARTICULAR PURPOSE, NONINFRINGEMENT, OR ARISING FROM A COURSE OF
DEALING, USAGE OR TRADE PRACTICE.

INTERFACE DEFINITION LANGUAGE CFE IS PROVIDED WITH NO SUPPORT AND WITHOUT
ANY OBLIGATION ON THE PART OF Sun OR ANY OF ITS SUBSIDIARIES OR AFFILIATES
TO ASSIST IN ITS USE, CORRECTION, MODIFICATION OR ENHANCEMENT.

SUN OR ANY OF ITS SUBSIDIARIES OR AFFILIATES SHALL HAVE NO LIABILITY WITH
RESPECT TO THE INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY
INTERFACE DEFINITION LANGUAGE CFE OR ANY PART THEREOF.

IN NO EVENT WILL SUN OR ANY OF ITS SUBSIDIARIES OR AFFILIATES BE LIABLE FOR
ANY LOST REVENUE OR PROFITS OR OTHER SPECIAL, INDIRECT AND CONSEQUENTIAL
DAMAGES, EVEN IF SUN HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

Use, duplication, or disclosure by the government is subject to
restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
Technical Data and Computer Software clause at DFARS 252.227-7013 and FAR
52.227-19.

Sun, Sun Microsystems and the Sun logo are trademarks or registered
trademarks of Sun Microsystems, Inc.

SunSoft, Inc.  
2550 Garcia Avenue 
Mountain View, California  94043
